package cn.com.ty.lift.common.constants;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

/**
 * @author huangyuan
 * @date 2020/4/17
 * @description 推送消息常量
 */
public class PushMessageConstants {

    /**
     * 推送值对应角色编码集合
     */
    public static HashMap<Integer, String[]> PUSH_VALUE_TO_ROLE_CODE;

    /**
     * 角色编码数组
     */
    public static final String[] ROLE_CODE_ARRAY = {
            //企业管理员
            CommonEnum.DefaultRole.ENTERPRISE_ADMIN.getCode(),
            //高级主管
            CommonEnum.DefaultRole.HIGH_DIRECTOR.getCode(),
            //区域主管
            CommonEnum.DefaultRole.REGION_DIRECTOR.getCode(),
            //文员
            CommonEnum.DefaultRole.CLERK.getCode(),
            //维保工
            CommonEnum.DefaultRole.MTWORK.getCode(),
            //财务
            CommonEnum.DefaultRole.FINANCE.getCode(),
    };

    /**
     * 企业管理员
     */
    public static final int PUSH_ONE = 1;
    /**
     * 企业管理员 + 高级主管
     */
    public static final int PUSH_TWO = 2;
    /**
     * 企业管理员 + 高级主管 + 区域主管
     */
    public static final int PUSH_THREE = 3;
    /**
     * 企业管理员 + 高级主管 + 区域主管 + 财务
     */
    public static final int PUSH_FOUR = 4;
    /**
     * 企业管理员 + 高级主管 + 区域主管 + 财务 + 文员
     */
    public static final int PUSH_FIVE = 5;
    /**
     * 企业管理员 + 高级主管 + 区域主管 + 财务 + 文员 + 维保工
     */
    public static final int PUSH_SIX = 6;

    /**
     * 推送情形数组
     */
    public static final int[] PUSH_SITUATION_ARRAY = {
            PUSH_ONE,
            PUSH_TWO,
            PUSH_THREE,
            PUSH_FOUR,
            PUSH_FIVE,
            PUSH_SIX
    };

    static {
        //初始化map
        PUSH_VALUE_TO_ROLE_CODE = new HashMap<>();
        //角色编码集合
        List<String> roleCodes = new LinkedList<>();
        //推送情形对应角色编码数组
        for (int i = 0; i < PUSH_SITUATION_ARRAY.length; i++) {
            roleCodes.add(ROLE_CODE_ARRAY[i]);
            PUSH_VALUE_TO_ROLE_CODE.put(PUSH_SITUATION_ARRAY[i], roleCodes.toArray(new String[i + 1]));
        }
    }

}
